﻿Type=Service
Version=7.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'BLE REMOTE CENTRAL 2 - Module Starter
'Suggested by Erel - Anywhere Software



#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'Erel's Codes
	Private Manager1, Manager2 As BleManager2
	Private managers As Map
End Sub

Sub Service_Create
	'Erel' Codes
	Manager1.Initialize("Manager")
	Manager2.Initialize("Manager")
	managers = CreateMap(Manager1: "m1", Manager2: "m2")
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy
	Manager1.Disconnect
	Manager2.Disconnect
End Sub


'==============================================================================================================================================
'                                                           ORIGINAL CODES FROM EREL
'==============================================================================================================================================
'Sub Manager_StateChanged (State As Int)
'	Dim m As BleManager2 = Sender
'	Log("StateChanged: " & managers.Get(m) & ", " & State)
'	If State = m.STATE_POWERED_ON Then
'		m.Scan(Null)
'	End If
'End Sub
'
'Sub Manager_DeviceFound (Name As String, DeviceId As String, AdvertisingData As Map, RSSI As Double)
'	Dim m As BleManager2 = Sender
'	Log("Manager_DeviceFound: " & managers.Get(m) & ", " & DeviceId & ", " & Name)
'	Dim TargetName As String
'	If managers.Get(m) = "m1" Then TargetName = "BLE SWITCH 1" Else TargetName = "BLE SWITCH 2"
'	If Name = TargetName Then
'		Log("Trying to connect")
'		m.Connect2(DeviceId, False)
'	End If
'End Sub
'
'Sub Manager_Connected (Services As List)
'	Log("Manager_Connected: " & managers.Get(Sender))
'End Sub
'
'Sub Manager_Disconnected
'	Log("Manager_Disconnected: " & managers.Get(Sender))
'End Sub
'=========================================================================================================================== ORIGINAL CODES END

'==============================================================================================================================================
'                                                            MODIFIED CODES BY LVH
'==============================================================================================================================================
Sub Manager_StateChanged (State As Int)
	Dim m As BleManager2 = Sender
	Log("StateChanged: " & managers.Get(m) & ", " & State)
	If State = m.STATE_POWERED_ON Then
		'm.Scan(Null)							'Start Manager1 and Manager2 Scanning
		Manager1.Scan(Null)						'Start Manager1 only
	End If
End Sub

Sub Manager_DeviceFound (Name As String, DeviceId As String, AdvertisingData As Map, RSSI As Double)
	Dim m   As BleManager2
	Dim mID As String
	m = Sender
	mID = managers.Get(m)
	Log("Manager_DeviceFound: " & mID & ", " & DeviceId & ", " & Name)
	Dim TargetName As String
	If mID = "m1" Then TargetName = "BLE SWITCH 1" Else TargetName = "BLE SWITCH 2"
	If Name = TargetName Then
		m.StopScan
		Log(mID & " - Trying to connect")
		m.Connect2(DeviceId, False)
	End If
End Sub

Sub Manager_Connected (Services As List)
	Private m   As BleManager2
	Private mID As String
	
	m = Sender
	mID = managers.Get(m)
	Log("Manager_Connected: " & mID)
	
	Select mID
		Case "m1"
			Manager2.Scan(Null)
		Case "m2"
	End Select
End Sub

Sub Manager_Disconnected
	Private m   As BleManager2
	Private mID As String
	
	m = Sender
	mID = managers.Get(m)
	Log("Manager_Disconnected: " & managers.Get(Sender))
	
End Sub
'================================================================================================================================ LVH CODES END